/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package aracloud;

import java.nio.file.*;
import static java.nio.file.StandardWatchEventKinds.*;
import java.io.File;
/**
 *
 * @author marcelo
 */

public class AraCloud {

    /* Create the object that will monitor the events of the folder */

    private static WatchService createWatcher(String directory){
        try{
            WatchService watcher = FileSystems.getDefault().newWatchService();
            Path dir = Paths.get(directory);
            dir.register(watcher, ENTRY_CREATE, ENTRY_DELETE, ENTRY_MODIFY);

            return watcher;
        }
        catch(java.io.IOException c){
            return null;
        }
    }

    private static void createRecursiveWatcher(String directory, SCPFileSender f, String remoteFolder){
        try{

            File file = new File(directory);

            for(File i : file.listFiles()){

                if(i.isDirectory()){
                    WatchService newWatch = createWatcher(i.getAbsolutePath());
                    FileMonitor monitor = new FileMonitor(newWatch, f, i.getAbsolutePath(), remoteFolder + "/" + i.getName());
                    monitor.start();
                    createRecursiveWatcher(directory + i.getName()+"/", f, remoteFolder + "/" + i.getName());
                }
            }

        }
        catch(Exception e){
            System.out.println(e);
        }
    }

    public static void main(String[] args) {

        System.out.println("Welcome to AraCloud. Parsing existing data");

        String folderPath = "/home/marcelo/Test/";
        String fileData = folderPath + ".file_data";
        String remoteFolder = "WWW/localfolder";

        ConfManager initScan = new ConfManager(fileData, folderPath);
        SCPFileSender fs = new SCPFileSender();
        fs.createSession();
        System.out.println("Conexión con aragorn exitosa. Creando watchers");

        WatchService main = createWatcher(folderPath);
        FileMonitor monitor = new FileMonitor(main, fs, folderPath, remoteFolder);
        monitor.start();

        createRecursiveWatcher(folderPath, fs, remoteFolder);

    }

}
